=== debian/changelog ===
openjdk-9 (9~b134-2ubuntu1) yakkety; urgency=medium

  * Explicitly turn off stack-protector for zero builds.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 08 Sep 2016 17:21:13 +0200

openjdk-9 (9~b134-2) experimental; urgency=medium

  * Build using GCC 6.
  * Enable zero build on arm64 and ppc64el.
  * Increase thread stack size for ppc* zero builds.
  * Don't use Solaris compiler flags on sparc64.
  * Port x32 zero patch.
  * Don't use the just built jdk for zero builds.
  * Don't use getFileStore() during the build, chroots throw an
    exception while running jlink.
  * Fix removal of jre-headless alternatives. Closes: #788445.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 05 Sep 2016 14:14:01 +0200

openjdk-9 (9~b133-2) experimental; urgency=medium

  * Don't do bootcycle builds for zero builds.
  * Fix macro settings for zero builds.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 31 Aug 2016 18:34:51 +0200

openjdk-9 (9~b133-1) experimental; urgency=medium

  * OpenJDK 9, b133.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 29 Aug 2016 14:25:48 +0200

openjdk-9 (9~b130-1) experimental; urgency=medium

  * OpenJDK 9, b130.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Aug 2016 23:27:51 +0200

openjdk-9 (9~b124-1) experimental; urgency=medium

  * OpenJDK 9, b124.
  * Fix an issue with libatk-wrapper (Samuel Thibault). Closes: #827796.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 28 May 2016 22:30:12 +0200

openjdk-9 (9~b117-1) experimental; urgency=medium

  * OpenJDK 9, b117.
  * Fix zero builds, next try.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 May 2016 23:10:57 +0200

openjdk-9 (9~b116-1) experimental; urgency=medium

  * OpenJDK 9, b116.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 29 Apr 2016 00:41:04 +0200

openjdk-9 (9~b115-2) experimental; urgency=medium

  * Fix zero builds:
    - Backport 8132051, 8146518, 8150654, 8154210 from the hs repo.
    - Apply proposed patch for 8153275.
  * Set initial VMThreadStackSize to 1600 on s390x.
  * Tighten openjdk build dependency on s390x.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Apr 2016 23:09:19 +0200

openjdk-9 (9~b115-1) experimental; urgency=medium

  * OpenJDK 9, b115.
  * Fix header file conflict. Closes: #816440. LP: #1550950.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 21 Apr 2016 23:48:04 +0200
